#!/bin/sh

#############################################
### FileName:autosetup.sh
### Auth:Sunshine Gu
### Version: v1.0.0
### http://blog.hit008.com
### Bash shell for DDos_Drop Quick-Install.
#############################################

# Check if user is root
if [ $(id -u) != "0" ]; then
    echo "Error: You must be root to run this script, use sudo sh $0"
    exit 1
fi

clear
echo "========================================================================="
echo "***** Starting DDos_Drop Quick-Install: " `date`
echo "***** Installing pre-requisites"
echo "========================================================================="

# Update iptables. 
yum install -y iptables*
yum update -y iptables*
yum install -y gcc*
yum update -y gcc*
chkconfig --add iptables
chkconfig iptables on
setenforce 0
echo "========================================================================="

# Create main directory
if [ -d /usr/local/ddos_drop ];then
echo "This folder exist,Will be rebuild..."
rm -rf /usr/local/ddos_drop
fi
mkdir -p /usr/local/ddos_drop
mkdir -p /usr/local/ddos_drop/bin
mkdir -p /usr/local/ddos_drop/conf
mkdir -p /usr/local/ddos_drop/logs
echo "Rebuild Done."


# Makefile(*.c)
if [ -e ./ddos_acl.c ];then
gcc ddos_acl.c -o ddos_acl || exit 1
else
echo "ddos_acl.c does not exist!"
exit 1
fi
if [ -e ./flush_drop.c ];then
gcc flush_drop.c -o flush_drop || exit 1
else
echo "ddos_acl.c does not exist!"
exit 1
fi

# Copy file to main directory
echo -n "Create ddos_acl..."
cp ddos_acl /usr/local/ddos_drop/bin/
cp ddos_acl.c /usr/local/ddos_drop/bin/
echo "Done."
echo -n "Create flush_drop..."
cp flush_drop /usr/local/ddos_drop/bin/
cp flush_drop.c /usr/local/ddos_drop/bin/
echo "Done."
cp dd_start /usr/local/ddos_drop/bin/
cp conf/ddos_drop.conf /usr/local/ddos_drop/conf/

# Setting $PATH
echo -n "Setting Environment variables..."
if [ `cat ~/.bash_profile|grep 'ddos_drop'|wc -l` -eq 0 ];then
echo "PATH=$PATH:/usr/local/ddos_drop/bin" >> ~/.bash_profile
export PATH=$PATH:/usr/local/ddos_drop/bin
fi
if [ `cat /etc/rc.local|grep 'ddos_drop'|wc -l` -eq 0 ];then
echo "/usr/local/ddos_drop/bin/dd_start start" >> /etc/rc.local
fi
echo "Done."

# Start The main program
echo "====================================================="
echo "All things is OK!"
echo "Main directory:/usr/local/ddos_drop/"
echo "Press used 'dd_start start' to start the firewall."
echo "dd_start {start|stop|restart|status}"
echo "Happy to use!"
echo "====================================================="
